---
title: Permissions.query()
slug: Web/API/Permissions/query
tags:
  - API
  - Experimental
  - Method
  - Permissions
  - Reference
---
<p>{{APIRef("Permissions API")}}{{SeeCompatTable}}</p>

<p>The <strong><code>Permissions.query()</code></strong> method of the {{domxref("Permissions")}} interface returns the state of a user permission on the global scope.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">navigator.permissions.query(PermissionDescriptor).then(function(permissionStatus) { ... })</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>PermissionDescriptor</code></dt>
 <dd>An object that sets options for the <code>query</code> operation consisting of a comma-separated list of name-value pairs. The available options are:
 <ul>
  <li><code>name</code>: The name of the API whose permissions you want to query. An up-to-date list of permission names can be found in the spec under the <a href="https://w3c.github.io/permissions/#enumdef-permissionname">PermissionName enum</a>, but bear in mind that the actual permissions supported by browsers is currently much smaller than this. Firefox for example currently supports <code>geolocation</code>, <code>notifications</code>, <code>push</code>, and <code>persistent-storage</code> (see our <a href="https://dxr.mozilla.org/mozilla-central/source/dom/webidl/Permissions.webidl#10"><code>Permissions.webidl</code> file</a>).</li>
  <li><code>userVisibleOnly</code>: (Push only, not supported in Firefox — see the Browser Support section below) Indicates whether you want to show a notification for every message or be able to send silent push notifications. The default is <code>false</code>.</li>
  <li><code>sysex</code>: (Midi only) Indicates whether you need and/or receive system exclusive messages. The default is <code>false</code>.</li>
 </ul>
 </dd>
</dl>

<div class="note">
<p><strong>Note</strong>: As of Firefox 44, the permissions for <a href="/en-US/docs/Web/API/Notifications_API">Notifications</a> and <a href="/en-US/docs/Web/API/Push_API">Push</a> have been merged. If permission is granted (e.g. by the user, in the relevant permissions dialog), <code>navigator.permissions.query()</code> will return <code>true</code> for both <code>notifications</code> and <code>push</code>.</p>
</div>

<div class="note">
<p><strong>Note</strong>: The <code>persistent-storage</code> permission allows an origin to use a persistent box (i.e <a href="https://storage.spec.whatwg.org/#persistence">persistent storage</a>) for its storage, as per the <a href="https://storage.spec.whatwg.org/">Storage API</a>.</p>
</div>

<h3 id="Returns">Returns</h3>

<p>A {{jsxref("Promise")}} that resolves to a {{domxref("PermissionStatus")}} object.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TypeError</code></td>
   <td>Retrieving the <code>PermissionDescriptor</code> information failed in some way, or the permission doesn't exist or is currently unsupported (e.g. <code>midi</code>, or <code>push</code> with <code>userVisibleOnly</code>).</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<pre class="brush: js">navigator.permissions.query({name:'geolocation'}).then(function(result) {
 if (result.state == 'granted') {
   showLocalNewsWithGeolocation();
 } else if (result.state == 'prompt') {
   showButtonToEnableLocalNews();
 }
 // Don't do anything if the permission was denied.
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Permissions API','#dom-permissions-query','query()')}}</td>
   <td>{{Spec2('Permissions API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Permissions.query")}}</p>
</div>
